generic
SIZE: POSITIVE;
type POLOZKA is private;
package STACK5 is
	task ZASOBNIK is
		entry VLOZ(X: in POLOZKA);
		entry UBER(X: out POLOZKA);
	end ZASOBNIK;
end STACK5;

package body STACK5 is
	task body ZASOBNIK is
	S: array (1..SIZE) of POLOZKA;
	SP: INTEGER range 0..SIZE;
	begin
		SP := 0;
		loop
			select
				when SP < SIZE =>
					accept VLOZ(X : in POLOZKA) do
						SP := SP + 1;
						S(SP) := X; 
                    end VLOZ;
			or
				when SP > 0 =>
					accept UBER(X : out POLOZKA) do
						X := S(SP);
						SP := SP - 1;
					end UBER;
			or 
				terminate;
			end select;
		end loop;
	end ZASOBNIK;
end STACK5;

with STACK5, TEXT_IO; use TEXT_IO;
procedure MAIN is
	package STACKI is new STACK5(20, INTEGER);
	package STACKC is new STACK5(100, CHARACTER);
	C,D: CHARACTER := 'A';
	I: INTEGER := 111;
begin --...
	STACKC.ZASOBNIK.VLOZ('B');	--	. . .
	STACKC.ZASOBNIK.VLOZ(D);
	STACKI.ZASOBNIK.VLOZ(22);	--	. . .
	STACKC.ZASOBNIK.UBER(C);
    PUT(C); 
	STACKC.ZASOBNIK.UBER(D);
	PUT(D);
	--...
end MAIN;
