with TEXT_IO; use TEXT_IO;
procedure NAS_MAT is
   type RADKOVA_MATICE is array (INTEGER range <>) of FLOAT;
   type POINTER is access RADKOVA_MATICE;
   RAD: INTEGER;
   package I_IO is new INTEGER_IO(INTEGER); use I_IO;
   package F_IO is new FLOAT_IO(FLOAT); use F_IO;
   task type PARCIALNI_SOUCIN is
      entry PRIJATA_HODNOTA(P : out FLOAT);
      entry VYSLANA_HODNOTA(V_1, V_2: in RADKOVA_MATICE);
   end PARCIALNI_SOUCIN;
   task body PARCIALNI_SOUCIN is
      SOUCIN: FLOAT;
      VEKTOR_1, VEKTOR_2: POINTER;
   begin
      accept VYSLANA_HODNOTA(V_1,V_2: in RADKOVA_MATICE) do
	 VEKTOR_1 := new RADKOVA_MATICE'(V_1); --inicializuje VEKTOR_1
	 VEKTOR_2 := new RADKOVA_MATICE'(V_2); --hodnotou V_1, pod.V_2
      end VYSLANA_HODNOTA;
      SOUCIN := 0.0;
      for I in VEKTOR_1.all'RANGE   --ukazuje na RADKOVA_MATICE
	 loop SOUCIN := SOUCIN + (VEKTOR_1(I)*VEKTOR_2(I));
      end loop;
      accept PRIJATA_HODNOTA(P: out FLOAT) do
	 P := SOUCIN;
      end PRIJATA_HODNOTA;
   end PARCIALNI_SOUCIN;
begin
   put_line("zadej rad integer"); get(RAD);
   declare
      type MATICE is array(1..RAD) of RADKOVA_MATICE(1..RAD);
      X:MATICE;
      U,P:RADKOVA_MATICE(1..RAD);
      PARALELNI_SOUCIN: array(U'RANGE) of PARCIALNI_SOUCIN;
   begin
      put_line("zadej realove prvky matice");
      for I in X'RANGE loop
	 for J in U'RANGE loop
	    GET(X(I)(J));
	 end loop;
      end loop;
      put_line("zadej realove prvky vektoru");
      for I in U'RANGE loop GET(U(I));
      end loop; --tento cyklus musi byt zvlast od toho nasledujiciho
      for I in U'RANGE loop
	 PARALELNI_SOUCIN(I).VYSLANA_HODNOTA(X(I), U);
      end loop;
      for I in P'RANGE loop
	 PARALELNI_SOUCIN(I).PRIJATA_HODNOTA(P(I));
	 PUT(P(I)); NEW_LINE;
      end loop;
   exception when DATA_ERROR=>PUT_LINE("VADNY TYP");
   end;
end NAS_MAT;


