class MyThread implements Runnable { 
  int count; 
  String thrdName; 
 
  MyThread(String name) { 
    count = 0; 
    thrdName = name; 
  } 
 
    public void run() { // vstupni bod vlakna
    System.out.println(thrdName + " startuje."); 
    try {  
      do { 
        Thread.sleep(50); 
        System.out.println("Ve vlaknu " + thrdName + 
                           ", citac je " + count); 
        count++; 
      } while(count < 5); 
    } 
    catch(InterruptedException exc) { 
      System.out.println(thrdName + " prerusene."); 
    } 
    System.out.println(thrdName + " ukoncene."); 
  } 
} 
 
class Vlakno { 
  public static void main(String args[]) { 
    System.out.println("Hlavni vlakno startuje"); 
 
    // Nejdve konstruujeme MyThread objekt. 
    MyThread mt = new MyThread("potomek"); 
 
    // Pak konstruujeme vlakno z tohoto objektu 
    Thread newThrd = new Thread(mt); 
 
    // Az pak startujeme vypocet vlakna 
    newThrd.start(); 
 
    do { 
      System.out.print("."); 
      try { 
        Thread.sleep(10); 
      } 
      catch(InterruptedException exc) { 
        System.out.println("Hlavni vlakno prerusene."); 
      } 
    } while (mt.count != 5); 
 
    System.out.println("Konci hlavni vlakno"); 
  } 
} 
