 class MyThread extends Thread { 
  int count; 
 
  MyThread(String name) {
    super(name); 
    count = 0; 
    start(); // start  
  } 
 
  public void run() { 
    System.out.println(getName() + " startuje"); 
    try {  
      do { 
        Thread.sleep(500); 
        System.out.println("Ve " + getName() + 
                           ", citac je " + count); 
        count++; 
      } while(count < 3); 
    } 
    catch(InterruptedException exc) { 
      System.out.println(getName() + " preruseny"); 
    } 
    System.out.println(getName() + " konci"); 
  } 
} 
 
class Join { 
    public static void main(String args[]) { 
    System.out.println("Hlavni vlakno startuje"); 
 
    MyThread mt1 = new MyThread("potomek1"); 
    MyThread mt2 = new MyThread("potomek2"); 
    MyThread mt3 = new MyThread("potomek3"); 

    try { 
      mt3.join(); 
      System.out.println("potomek3 joined."); 
      mt2.join(); 
      System.out.println("potomek2 joined."); 
      mt1.join(); 
      System.out.println("potomek1 joined."); 
    } 
    catch(InterruptedException exc) { 
      System.out.println("Hlavni vlakno prerusene"); 
    } 
 
    System.out.println("Hlavni vl. konci"); 
  } 
}